#include "Bomber.hpp"
//WeberMa73121: implementation enum direction dir replaces int direcion---------------------------------------
//Hauerch71498 ----------------------------------------------------------------------------------------------
Bomber::Bomber(float x, float y, enum direction dir, int animationstep)
 : Enemy(5,x,y,dir,animationstep)
{
}
int Bomber::getScore()
{
    return 1000;
}
static StaticPixelBuffer<15,9> constexpr front[2] = {
    {{{
        {"    2     2    "},
        {"    2     2    "},
        {"    2     2    "},
        {"    2 121 2    "},
        {"   111222111   "},
        {"222111222111222"},
        {" 1  1111111  1 "},
        {" 5           5 "},
        {" 3           3 "}
    }}},
    {{{
         {"    2     2    "},
         {"    2     2    "},
         {"    2     2    "},
         {"    2 121 2    "},
         {"   111222111   "},
         {"222111222111222"},
         {" 1  1111111  1 "},
         {" 5           5 "},
         {" 3           3 "}
     }}}
    };
static StaticPixelBuffer<15,9> constexpr back[2] = {
    {{{
        {"    2     2    "},
        {"    2     2    "},
        {"    2     2    "},
        {"    2 121 2    "},
        {"   121111121   "},
        {"222133212331222"},
        {" 1  7711177  1 "},
        {" 3           3 "},
        {" 5           5 "}
    }}},
    {{{
         {"    2     2    "},
         {"    2     2    "},
         {"    2     2    "},
         {"    2 121 2    "},
         {"   121111121   "},
         {"222177212771222"},
         {" 1  3311133  1 "},
         {" 3           3 "},
         {" 5           5 "}
     }}}
    };

static StaticPixelBuffer<23,11> constexpr right[2] = {
    {{{
         {"2                      "},
         {"22                     "},
         {"212                    "},
         {"21121111         22    "},
         {"221111111111111122221  "},
         {"32111111111111111111111"},
         {"7212111111112111111111 "},
         {"212    21112           "},
         {" 2      222            "},
         {"       555553          "},
         {"                       "}
    }}},
    {{{
         {"2                      "},
         {"22                     "},
         {"212                    "},
         {"21121111         22    "},
         {"221111111111111122221  "},
         {"72111111111111111111111"},
         {"3212111111112111111111 "},
         {"212    21112           "},
         {" 2      222            "},
         {"       555553          "},
         {"                       "}
     }}}
    };

static StaticPixelBuffer<23,11> constexpr left[2] = {
    {{{
         {"                      2"},
         {"                     22"},
         {"                    212"},
         {"    22         11112112"},
         {"  122221111111111111122"},
         {"11111111111111111111123"},
         {" 1111111112111111112127"},
         {"           21112    212"},
         {"            222      2 "},
         {"          355555       "},
         {"                       "}


    }}},
    {{{
         {"                      2"},
         {"                     22"},
         {"                    212"},
         {"    22         11112112"},
         {"  122221111111111111122"},
         {"11111111111111111111127"},
         {" 1111111112111111110123"},
         {"           21112    212"},
         {"            222      2 "},
         {"          355555       "},
         {"                       "}
     }}}
    };

PixelBuffer const& Bomber::getSprite()
{
    switch (dir) {

    case direction::FRONT:
        return front[animationstep];
        break;
    case direction::LEFT:
        return left[animationstep];
        break;
    case direction::RIGHT:
        return right[animationstep];
        break;

    default:
        return back[animationstep];
    }
};

void Bomber::move(FloatSeconds const & Frametime, [[maybe_unused]] Level &level)
{
    if(animationtimer>10*Frametime.count())
    {
        animationstep = 1-animationstep;
        animationtimer = 0;
    }
    else
    {
        animationtimer += Frametime.count();
    }
    /*replace with Pathfinding*/
    switch ( this->dir ) {
    case direction::FRONT: //front
                this->topleft.Y += 10*Frametime.count();
        break;
    case direction::LEFT: //left
                this->topleft.X -= 10*Frametime.count();
        break;
    case direction::RIGHT: //right
                this->topleft.X += 10*Frametime.count();
        break;
    default:
        this->topleft.Y -= 10*Frametime.count();
        break;
        //exception
        break;
    }
};

void Bomber::doStep(float PlayerX, float PlayerY, FloatSeconds const & Frametime, Level &level) //Pathfinding easier with full level, not used currently.
{
    timetillreload -= Frametime.count();
    if(lookAtPlayer(PlayerX,PlayerY, level))
    {
        shoot(level);
    }
        move(Frametime, level); //Immer in Bewegung.
};
