#ifndef ENEMY_HPP
#define ENEMY_HPP

#include "Entity.hpp"
#include "PixelBuffer.hpp"
#include "Platform.hpp"
//WeberMa73121: implementation enum direction dir replaces int direcion---------------------------------------
//Hauerch71498 ----------------------------------------------------------------------------------------------
class Level;

/* Vaterklasse Enemy ermöglicht es alle Kindklassen Enemytyp einfach anzusprechen.
 * Die Ai wird von den Kindern Ersetzt(virtual), soll Zugriff allgemeinisieren
 * restliche funktionen sind in Kindspezifisch, durch enum Type gibt es eine leichte zweifach verbindung.
*/

class Enemy : public Entity
{
public:
    Enemy(int Health, float x, float y, enum direction dir, int animationstep);
    virtual int getScore() = 0;
protected:

    direction dir;
    float timetillreload = 0;
    float animationtimer = 0;
    //Kann nicht copy
    int animationstep; //die jeweiligen animationsBilder

    bool playerdetected(float PlayerX, float PlayerY, Level &level);
    void shoot(Level &level); //die Schuss Funktion
    virtual void move(FloatSeconds const & Frametime, Level &level);
    bool lookup(float PlayerY, Level &level);
    bool lookdown(float PlayerY, Level &level);
    bool lookleft(float PlayerX, Level &level);
    bool lookright(float PlayerX, Level &level);
    bool lookAtPlayer(float PlayerX, float PlayerY, Level &level);
    void turnToPlayer(float PlayerX, float PlayerY);

};

#endif // ENEMY_HPP
