#ifndef PIXELSHADERS_HPP
#define PIXELSHADERS_HPP

#include "Platform.hpp"

class HitShader : public ShadedPixelBuffer {
public:
	float percent;
	Color color;
	bool is_final;

	HitShader(
		PixelBuffer const &input, float percent, Color color, bool is_final
	) :
		ShadedPixelBuffer(input),
		percent(percent),
		color(color),
		is_final(is_final) {
	}

	virtual Color peek_unchecked(PixelPoint const &pos) const;
};

class DiagonalFadeoutShader : public ShadedPixelBuffer {
public:
	float percent;

	DiagonalFadeoutShader(PixelBuffer const &input, float percent) :
		ShadedPixelBuffer(input), percent(percent) {
	}

	virtual Color peek_unchecked(PixelPoint const &pos) const;
};

#endif /* PIXELSHADERS_HPP */
