#ifndef POSITION_HPP
#define POSITION_HPP

// World and screen space positions.

struct PixelPoint {
    int x;
    int y;

    bool operator !=(PixelPoint const &other) const {
        return ((x != other.x) || (y != other.y));
    }

    friend PixelPoint operator +(PixelPoint const &lhs, PixelPoint const &rhs) {
        return { (lhs.x + rhs.x) , (lhs.y + rhs.y) };
    }
};

class Position
{
public:
    float X;
    float Y;

     bool operator ==(Position const &other) const {
        return ((X == other.X) && (Y == other.Y));
    }

    operator PixelPoint() const {
        return { static_cast<int>(X), static_cast<int>(Y) };
    }
};
enum class direction {BACK, FRONT, RIGHT, LEFT};

#endif // POSITION_HPP
