#include "Level.hpp"
#include "Trooper.hpp"
//WeberMa73121: implementation enum direction dir replaces int direction---------------------------------------
//Hauerch71498 ----------------------------------------------------------------------------------------------

Trooper::Trooper(float x, float y, enum direction dir, int animationstep)
 : Enemy(1,x,y,dir,animationstep)
{
    animationtimer = 0;
}

int Trooper::getScore()
{
    return 100;
}
static StaticPixelBuffer<5,9> constexpr front[2] = {
                                          {{{
                                              {"  1  "},
                                              {" 111 "},
                                              {" 161 "},
                                              {" 5521"},
                                              {"52255"},
                                              {"2255 "},
                                              {"1555 "},
                                              {" 5 5 "},
                                              {" 1 11"}
                                          }}},
                                          {{{
                                               {"  1  "},
                                               {" 111 "},
                                               {" 161 "},
                                               {" 5521"},
                                               {"52255"},
                                               {"2255 "},
                                               {"1555 "},
                                               {" 5 5 "},
                                               {"11 1 "}
                                          }}}
                                          };
static StaticPixelBuffer<5,9> constexpr back[2] = {
                                          {{{
                                              {"  1  "},
                                              {" 111 "},
                                              {" 1112"},
                                              {" 5551"},
                                              {"55555"},
                                              {"5555 "},
                                              {"2555 "},
                                              {" 5 5 "},
                                              {"11 1 "}
                                          }}},
                                          {{{
                                               {"  1  "},
                                               {" 111 "},
                                               {" 1112"},
                                               {" 5551"},
                                               {"55555"},
                                               {"5555 "},
                                               {"2555 "},
                                               {" 5 5 "},
                                               {" 1 11"}
                                          }}}
                                          };
static StaticPixelBuffer<5,9> constexpr left[2] = {
                                          {{{
                                              {"  1  "},
                                              {"2 11 "},
                                              {"2 61 "},
                                              {"2555 "},
                                              {"2 55 "},
                                              {"2555 "},
                                              {"2 55 "},
                                              {"  5  "},
                                              {" 11  "}
                                          }}},
                                          {{{
                                               {"  1  "},
                                               {"2 11 "},
                                               {"2 61 "},
                                               {"2555 "},
                                               {"2 55 "},
                                               {"2555 "},
                                               {"2 55 "},
                                               {"  55 "},
                                               {" 11 1"}
                                          }}}
                                          };
static StaticPixelBuffer<5,9> constexpr right[2] = {
                                          {{{
                                              {"  1  "},
                                              {" 11 2"},
                                              {" 1605"},
                                              {" 5552"},
                                              {" 55 2"},
                                              {" 5555"},
                                              {" 55 2"},
                                              {"  5  "},
                                              {"  11 "}
                                          }}},
                                          {{{
                                               {"  1  "},
                                               {" 11 2"},
                                               {" 1605"},
                                               {" 5552"},
                                               {" 55 2"},
                                               {" 5555"},
                                               {" 55 2"},
                                               {" 55  "},
                                               {"1 11 "}
                                          }}}
                                          };
PixelBuffer const& Trooper::getSprite()
{
    switch (dir) {

    case direction::BACK:
        return back[animationstep];
        break;
    case direction::LEFT:
        return left[animationstep];
        break;
    case direction::RIGHT:
        return right[animationstep];
        break;

    default:
        return front[animationstep];
    }
};


/*void Trooper::shoot()
{
  //TODO how do Projectile?
};*/

void Trooper::changeDirection()
{
    dir=direction(rand()%4);
};

bool Trooper::checkmove(FloatSeconds const & Frametime, Level &level)
{
    auto const &sprite = this->getSprite();
    switch (this->dir)
    {
        case direction::BACK: //down
            if(!level.checkCollision(this->topleft.X, this->topleft.Y - 3*Frametime.count(), sprite.w(), sprite.h()))
                {this->topleft.Y -= 3*Frametime.count(); return false;}
            else return true;
            break;
        case direction::LEFT:
        if(!level.checkCollision(this->topleft.X - 3*Frametime.count(), this->topleft.Y, sprite.w(), sprite.h()))
             {this->topleft.X -= 3*Frametime.count(); return false;}
        else return true;
            break;
        case direction::RIGHT:
            if(!level.checkCollision(this->topleft.X + 3*Frametime.count(), this->topleft.Y, sprite.w(), sprite.h()))
                 {this->topleft.X += 3*Frametime.count(); return false;}
            else return true;
            break;
        default:
            if(!level.checkCollision(this->topleft.X, this->topleft.Y + 3*Frametime.count(), sprite.w(), sprite.h()))
                {this->topleft.Y += 3*Frametime.count(); return false;}
            else return true;
            break;
    }
};

void Trooper::move(FloatSeconds const & Frametime, Level &level)
{
    if(animationtimer>0.3)
    {
        animationstep = 1-animationstep;
        animationtimer = 0;
    }
    else
    {
        animationtimer += Frametime.count();
    }
    if(checkmove(Frametime, level)) //Also moved when false;
    {
        changeDirection();
    }
};

void Trooper::turnToPlayer(float PlayerX, float PlayerY)
{
    if(abs(this->topleft.X - PlayerX) < 5) //buffer of 5
    {
        if(this->topleft.Y > PlayerY)
        {
            dir=direction::FRONT; //up
        }
        else
        {
            dir=direction::BACK; //down
        }
    }
    else
    {
        if(this->topleft.X > PlayerX)
        {
            dir=direction::RIGHT;
        }
        else
        {
            dir=direction::LEFT;
        }
    }
};
void Trooper::doStep(float PlayerX, float PlayerY, FloatSeconds const & Frametime, Level &level) //Pathfinding easier with full level, not used currently.
{
    timetillreload -= Frametime.count();
    if(playerdetected(PlayerX,PlayerY, level))
    { //Look into each direction, if true turns and shoot!
        shoot(level);
    }
    else
    {
        move(Frametime, level);
    }
};
