#ifndef PLAYER_HPP
#define PLAYER_HPP

#include "PixelBuffer.hpp"
#include "Platform.hpp"
#include "Level.hpp"
#include "Position.hpp"

int constexpr PLAYER_W = 17;
int constexpr PLAYER_H = 11;
float constexpr RELOAD_TIME = 1.0f;

class Player : public Entity
{
protected:
    // Turned out to be way overkill given that we only draw a bar below the
    // sprite...
    class Shader : public PixelBuffer {
    protected:
        virtual Color peek_unchecked(PixelPoint const &pos) const;
    public:
        Player const &player;

        Shader(Player const &player);
    };

    int speed=48;
    direction dir=direction::BACK;
    int animationstep=0;
    float timetillreload=0.0f;
    float animationtimer=0.0f;
    Shader shader;
public:
    Player(float x, float y);
    PixelBuffer const& getSprite() override;
    void move(Platform &p, FloatSeconds const & Frametime, Level &level);
    void shoot(Level &level);
    const PixelBuffer& getLivesSprite();
};

#endif // PLAYER_HPP
